﻿namespace Model.Stub;

public class Stub : IDataManager
{

    private List<Artist> artists = new List<Artist>();

    public IEnumerable<Artist> Artists
    {
        get
        {
            return artists;
        }
    }

    private List<Album> albums = new List<Album>();

    public IEnumerable<Album> Albums
    {
        get
        {
            return albums;
        }
    }

    private List<Playlist> playlists = new List<Playlist>();

    public IEnumerable<Playlist> Playlists
    {
        get
        {
            return playlists;
        }
    }

    private List<Title> titles = new List<Title>();

    public IEnumerable<Title> Titles
    {
        get
        {
            return titles;
        }
    }

    public Stub()
    {
        Artist Artiste1 = new Artist("Critien");
        Artist Artiste2 = new Artist("Gouriet");
        Artist Artiste3 = new Artist("Poulifer");
        Artist Artiste4 = new Artist("Credian");

        Album Album1 = new Album("la street", "lastreet.png", Artiste1, "c'est la street", "plein d'infos1");
        Album Album2 = new Album("la jsp", "oui.png", Artiste1, "c'est la couri", "plein d'infos2");
        Album Album3 = new Album("la pas le temps", "non.png", Artiste3, "c'est pas la street", "plein d'infos3");
        Album Album4 = new Album("la pas le choix", "peutetre.png", Artiste4, "c'est la parterre", "plein d'infos4");

        Artiste1.AddAlbum(Album1);
        Artiste1.AddAlbum(Album2);
        Artiste2.AddAlbum(Album3);
        Artiste2.AddAlbum(Album4);

        Playlist Playlist1 = new Playlist("Playlist1", "desc1", "url1.png");
        Playlist Playlist2 = new Playlist("Playlist2", "desc2", "url2.png");

        CustomTitle Custom1 = new CustomTitle("MaMusique", "url1.png", "info1", "chemin1");
        CustomTitle Custom2 = new CustomTitle("MusiqueGeniale", "url2.png", "info2", "chemin2");
        CustomTitle Custom3 = new CustomTitle("custom3", "url3.png", "info3", "chemin3");

        Playlist1.AddTitle(Custom1);
        Playlist1.AddTitle(Custom2);
        Playlist2.AddTitle(Custom2);
        Playlist2.AddTitle(Custom3);

        InfoTitle Info1 = new InfoTitle("info1", "url1.png", "info1", Artiste2, "desc1", Genre.K_POP);
        InfoTitle Info2 = new InfoTitle("info2", "url2.png", "info2", Artiste3, "desc2", Genre.GOSPEL);

        Album1.AddTitle(Info1);
        Album1.AddTitle(Info2);
        Album2.AddTitle(Info2);

        artists = new List<Artist>()
        {
            Artiste1,
            Artiste2,
            Artiste3,
            Artiste4
        };

        albums = new List<Album>()
        {
            Album1,
            Album2,
            Album3,
            Album4
        };

        playlists = new List<Playlist>()
        {
            Playlist1,
            Playlist2
        };

        titles = new List<Title>()
        {
            Custom1,
            Custom2,
            Custom3,
            Info1,
            Info2
        };
    }

    public List<Album> GetAlbums()
    {
        return albums;
    }

    public List<Artist> GetArtists()
    {
        return artists;
    }

    public List<Playlist> GetPlaylists()
    {
        return playlists;
    }

    public List<Title> GetTitles()
    {
        return titles;
    }

    public void AddAlbum(Album album)
    {
        albums.Add(album);
    }

    public void AddTitle(Title title)
    {
        titles.Add(title);
    }
    public void AddPlaylist(Playlist playlist)
    {
        playlists.Add(playlist);
    }

    public void AddArtist(Artist artist)
    {
        artists.Add(artist);
    }



    public void RemoveAlbum(Album album)
    {
        albums.Remove(album);
    }

    public void RemoveTitle(Title title)
    {
        titles.Remove(title);
    }

    public void RemovePlaylist(Playlist playlist)
    {
        playlists.Remove(playlist);
    }

    public void RemoveArtist(Artist artist)
    {
        artists.Remove(artist);
    }
}
